<template>
    <div>
        <div class="form-title mb-3 mt-3">
            <b>Campaign costs</b>
        </div>
        <div
            v-if="priceData"
            class="price-data col-8"
        >
            <b-row class="d-flex justify-content-between underlined">
                <div>Total subscribers:</div>
                <div>{{ priceData.total_subscribers }}</div>
            </b-row>

            <b-row class="d-flex justify-content-between underlined">
                <div>Total countries:</div>
                <div>{{ priceData.count_of_subscribers_countries }}</div>
            </b-row>

            <b-row class="d-flex justify-content-between underlined">
                <div>Total SMS cost:</div>
                <div>
                    <template v-if="loading">
                        Calculating...
                    </template>
                    <template v-else>
                        ${{ parseFloat(priceData.approximate_sms_campaign_cost).toFixed(2) }}*
                    </template>
                </div>
            </b-row>
        </div>
        <div class="postscript">
            *This is estimated cost. The final price depends on SMS provider policy. You will see the actual price in the campaign analytics.
        </div>
    </div>
</template>

<script>
    import smsCampaign from '@/mixins/sms/campaigns.service'

    export default {
        name: "PricingData",
        mixins: [smsCampaign],
        props: {
            countOfMessages: {
                type: Number,
                default: 0
            }
        },
        data(){
            return {
                priceData: {
                    total_subscribers: 0,
                    count_of_subscribers_countries: 0,
                    approximate_sms_campaign_cost: 0
                },
                timerId: null,
                loading: false,
            }
        },
        watch: {
            countOfMessages: {

                deep: true,
                handler() {
                    if (this.timerId){
                        clearTimeout(this.timerId);
                    }
                    this.loading = true
                    this.timerId = setTimeout(() => this.getPrice(), 2000);
                }
            }
        },
        mounted(){
            this.getPrice()
        },
        methods: {
            async getPrice() {
                this.loading = true
                this.priceData = await this.possiblePrice(this.countOfMessages);
                this.$emit('getPriceData', this.priceData)
                this.loading = false
            },
        },
    };
</script>

<style scoped lang="scss">
    .postscript {
        font-size: 10px;
        color: rgba(0,0,0,0.62);
        // margin-right: -180px;
    }
    .underlined {
        border-bottom: 1px solid rgba(0, 0, 0, 0.55);
        margin-bottom: 5px;
    }
    .price-data {
        padding-left: 13px;
        font-weight: bold;
        margin-bottom: 10px;
    }
</style>
